<?php
/**
* phpCan v.1
*
* $Id: tables.php 8 2009-06-08 21:54:24Z lito $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();


$config->tables = array(
	'actividade' => array(
		'tipo' => 'varchar',
		'data' => 'datetime',
		'activo' => 'boolean',
	),

	'comentarios' => array(
		'autor' => array(
			'format' => 'varchar',
			'required' => true
		),
		'email' => array(
			'format' => 'email',
			'required' => true
		),
		'texto' => array(
			'format' => 'text',
			'required' => true
		),
		'data' => 'datetime',
		'activo' => 'boolean',
	),

	'categorias' => array(
		'nome' => array(
			'format' => 'title',
			'required' => true
		),
		'texto' => array(
			'format' => 'text',
			'required' => true
		),
		'orde' => 'integer',
		'activo' => 'boolean',
	),

	'documentos' => array(
		'nome' => array(
			'format' => 'varchar',
			'required' => true
		),
		'arquivo' => array(
			'format' => 'file'
		)
	),

	'familias' => array(
		'nome' => array(
			'format' => 'title',
			'required' => true
		)
	),

	'fotografos' => array(
		'nome' => array(
			'format' => 'title',
			'required' => true
		),
		'texto' => 'wymeditor',
		'imaxe' => array(
			'format' => 'image',
			'max_width' => 1000,
			'max_height' => 1000,
			'dir' => 'fotografos'
		),
		'activo' => 'boolean',
	),

	'imaxes' => array(
		'titulo' => array(
			'format' => 'title',
			'required' => true
		),
		'descricion' => 'text',
		'imaxe' => array(
			'format' => 'image',
			'max_width' => 2000,
			'max_height' => 2000,
		),
		'ano' => array(
			'format' => 'integer',
			'length_max' => 4
		),
		'decada' => array(
			'format' => 'integer',
			'length_max' => 4
		),
		'lugar' => 'varchar',
		'posicion' => 'gmaps',
		'portada' => 'boolean',
		'activo' => 'boolean',
	),
	
	'imaxes_relacionadas' => array(
		'titulo' => array(
			'format' => 'title',
			'required' => true
		),
		'imaxe' => array(
			'format' => 'image',
			'max_width' => 2000,
			'max_height' => 2000,
		),
		'activo' => 'boolean',
	),

	'tags' => array(
		'tag' => array(
			'format' => 'title',
			'required' => true
		)
	),

	'relacions_tags_imaxes' => array(
		'posicion' => 'positionxy'
	),

	'textos' => array(
		'titulo' => array(
			'format' => 'varchar',
			'required' => true
		),
		'texto' => 'wymeditor',
		'localizacion' => 'varchar',
	),

	'videos_youtube' => array(
		'titulo' => array(
			'format' => 'varchar',
			'required' => true
		),
		'url' => array(
			'format' => 'varchar',
			'required' => true
		),
	),
);

$config->relations = array(
	array(
		'tables' => 'actividade comentarios',
		'mode' => 'x 1'
	),
	array(
		'tables' => 'actividade imaxes',
		'mode' => 'x 1'
	),
	array(
		'tables' => 'categorias imaxes',
		'mode' => '1 x'
	),
	array(
		'tables' => 'comentarios imaxes',
		'mode' => 'x 1'
	),
	array(
		'tables' => 'documentos imaxes',
		'mode' => 'x x'
	),
	array(
		'tables' => 'familias imaxes',
		'mode' => '1 x'
	),
	array(
		'tables' => 'fotografos imaxes',
		'mode' => '1 x'
	),
	array(
		'tables' => 'imaxes imaxes_relacionadas',
		'mode' => '1 x'
	),
	array(
		'tables' => 'imaxes videos_youtube',
		'mode' => '1 x'
	),
	array(
		'tables' => 'tags imaxes',
		'mode' => 'x x',
		'relation_table' => 'relacions_tags_imaxes'
	)
);
?>
