<?php
/**
* phpCan v.1
*
* $Id: save_config_saved-pages.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

if (!$vars->var['action']) {
	$vars->message('There is not action variable', 'ko');

	return false;
}

$table_admin = $data->tableExists('admin');

switch ($vars->var['action']) {
	case 'save':
		if (!$vars->var['title'] || !$vars->var['url']) {
			return false;
		}

		$data->save($table_admin, array(
			'insert' => array(
				'data' => array(
					'user' => $_SESSION['user'],
					'type' => 'saved-pages',
					'name' => $vars->str('title'),
					'value' => $vars->str('url')
				)
			)
		));
		break;

	case 'delete':
		if (!$vars->var['url']) {
			return false;
		}

		$data->save($table_admin, array(
			'delete' => array(
				'conditions' => array(
					'user' => $_SESSION['user'],
					'type' => 'saved-pages',
					'value' => $vars->str('url')
				)
			)
		));
		break;

	case 'rename':
		if (!$vars->var['title'] || !$vars->var['url']) {
			return false;
		}

		$data->save($table_admin, array(
			'update' => array(
				'data' => array(
					'name' => $vars->str('title')
				),
				'conditions' => array(
					'user' => $_SESSION['user'],
					'type' => 'saved-pages',
					'value' => $vars->str('url')
				),
				'limit' => 1
			)
		));
		break;

	default:
		$vars->message(__('Invalid action variable'), 'ko');

		return false;
}
?>
