<?php
/**
* phpCan v.1
*
* $Id: save_db.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

$vars->var['id'] = intval($vars->var[1]);

if (!$table = $data->tableExists($vars->var[0])) {
	$vars->message(__('The table "%s" doesn\'t exists', $table), 'ko');

	return false;
}

if ($action == 'duplicate-db') {
	unset($vars->var['id']);
}

//Build query
$action = ($vars->var['id'] > 0) ? 'update' : 'insert';

$options = array(
	$action => array(
		'data' => $vars->getTableVars($table),
		'overwrite_control' => $vars->getTableVars($table, '_default'),
		'conditions' => array(
			$table.'.id' => $vars->var['id']
		),
		'limit' => 1,
		'saveId' => 'id'
	)
);


//Unique relation
if ($vars->var['relate_table'] && $vars->var['relate_id'] && $action == 'insert') {
	$options[$action]['relate'][] = array(
		'table' => $vars->var['relate_table'],
		'name' => $vars->var['relate_name'],
		'conditions' => array(
			'id' => $vars->var['relate_id']
		)
	);
}


//Relations as selects
if (is_array($vars->var['relate'])) {
	foreach ($vars->var['relate'] as $rel) {
		if ($rel['id']) {
			$options[$action]['relate'][] = array(
				'table' => $rel['table'],
				'name' => $rel['name'],
				'conditions' => array(
					'id' => $rel['id']
				)
			);
		} else {
			$options[$action]['unrelate'][] = array(
				'table' => $rel['table'],
				'name' => $rel['name'],
			);
		}
	}
}

//Save data
$ok = $data->save($table, $options);

//Save 1x x relation
if ($vars->var['relation_table'] && $ok !== false) {
	//Build query
	$ids = $data->select($vars->var['relation_table'], array(
		'fields' => 'id',
		'conditions' => array(
			"$table.id" => $ok['id'],
			$vars->var['relate_table'].'.id' => $vars->var['relate_id']
		),
		'limit' => 1
	));
	
	$options = array(
		'update' => array(
			'data' => $vars->getTableVars($vars->var['relation_table'], '_relation'),
			'overwrite_control' => $vars->getTableVars($vars->var['relation_table'], '_relation_default'),
			'conditions' => array(
				'id' => $ids['id'],
			),
			'limit' => 1,
			'saveId' => 'id'
		)
	);

	//Relations as selects
	if (is_array($vars->var['relate_relation'])) {
		foreach ($vars->var['relate_relation'] as $rel) {
			if ($rel['id']) {
				$options['update']['relate'][] = array(
					'table' => $rel['table'],
					'name' => $rel['name'],
					'conditions' => array(
						'id' => $rel['id']
					)
				);
			} else {
				$options['update']['unrelate'][] = array(
					'table' => $rel['table'],
					'name' => $rel['name'],
				);
			}
		}
	}

	//Save data
	$ok2 = $data->save($vars->var['relation_table'], $options);
}

if ($ok === false) {
	$vars->message(__('Data wasn\'t saved. Check the input data'), 'ko');
} else {
	$session->saveActivity(array(
		'action' => $action,
		'table' => $table,
		'related_id' => $ok['id']
	));

	$config->actions[$action]['load'] = $ok['id'] ? path('edit-db', $table, $ok['id']).get() : path().get();

	if ($ok2 === false) {
		$vars->message(__('The data relation doesn\'t saved. Check the input data'), 'ko');
	} else {
		$vars->message(__('Data was saved successfully'), 'ok');
	}
}
?>
