<?php
/**
* phpCan v.1
*
* $Id: checkup.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include($data->load('validate_menu_extra'));

$data->register('checkup');

//PHP version
$checkup['php_version'] = array(
	'tittle' => __('PHP version'),
	'pass' => phpversion() > 5 ? 'yes' : 'no',
	'text' => __('The server version is').' "'.phpversion().'". '
);
if ($checkup['php_version']['pass'] == 'no') {
	$checkup['php_version']['text'] .= __('You need php5 or more');
}


//Files and folders permissions
$checkup['cache_permission'] = array(
	'tittle' => __('Cache folder permission'),
	'pass' => is_writable($config->paths['cache']) ? 'yes' : 'no'
);

if ($checkup['cache_permission']['pass'] == 'yes') {
	$checkup['cache_permission']['text'] = __('Your cache folder is writable');
} else {
	$checkup['cache_permission']['text'] = __('You must set writable permissions to your cache folder');
}


//PHP image library extension
$checkup['image_library']['tittle'] = __('Image manipulation library');
if (function_exists('gd_info')) {
	$gd_info = gd_info();
	$checkup['image_library']['text'] = __('You have installed the GD library').' / '.$gd_info['GD Version'];
	$checkup['image_library']['pass'] = 'yes';
} else if (extension_loaded('imagemagick')) {
	$checkup['image_library']['text'] = __('You have installed the "ImageMagick" library');
	$checkup['image_library']['pass'] = 'yes';
} else {
	$checkup['image_library']['text'] = __('You have installed no library');
	$checkup['image_library']['pass'] = 'no';
}


//PHP gettext extension
$checkup['gettext'] = array(
	'tittle' => __('Gettext extension'),
	'pass' => extension_loaded('gettext') ? 'yes' : 'no'
);

if ($checkup['gettext']['pass'] == 'yes') {
	$checkup['gettext']['text'] = __('You have activated gettext');
} else {
	$checkup['gettext']['text'] = __('You don\'t have activated gettext. You cannot make a multilanguage site');
}


//Database
$checkup['database'] = array(
	'tittle' => __('Database'),
	'pass' => $config->db['enabled'] && extension_loaded($config->db['type']) ? 'yes' : 'no',
	'server' => extension_loaded($config->db['type']) ? 1 : 0
);

$checkup['database']['text'] = __('Your database type is').' '.$config->db['type'];

if (!$checkup['database']['pass']) {
	$checkup['database']['text'] .= __('You have disabled the database or not installed');
}
?>
