<?php
/**
* phpCan v.1
*
* $Id: edit_db.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include($data->load('validate_controller'));

//Config
$data->register('config_edit_db', $config->admin_tables[$table]['menu-row']['edit-db']);
$data->register('config_direct_relations', $config->admin_tables[$table]['direct_relations']);


//Includes
if ($config_edit_db['includes'] && is_file($config->paths['admin-includes'].$config_edit_db['includes'].'.php')) {
	include ($config->paths['admin-includes'].$config_edit_db['includes'].'.php');
}


//Next-previous id
if ($vars->getKeyVar(1, 'next') || $vars->getKeyVar(1, 'prev')) {
	$id = intval($vars->getValueVar(1));
	$conditions = array();

	if ($vars->getKeyVar(1, 'prev') && $id > 0) {
		$conditions = array('id <' => $id);
		$sort = 'id DESC';
	} else if ($vars->getKeyVar(1, 'next') && $id > 0) {
		$conditions = array('id >' => $id);
		$sort = 'id ASC';
	}

	$new_id = $data->select($table, array(
		'fields' => 'id',
		'conditions' => $conditions,
		'limit' => 1,
		'sort' => $sort
	));

	if ($new_id['id']) {
		redirect(path(true, true, $new_id['id']));
	} else {
		if ($vars->getKeyVar(1, 'prev') && $id > 0) {
			$vars->message(__('This is the first register'), 'ko');
		} else if ($vars->getKeyVar(1, 'next') && $id > 0) {
			$vars->message(__('This is the last register'), 'ko');
		}

		redirect(path(true, true, $id));
	}
}

$vars->var['id'] = $vars->int(1);

//Select default
$default = $data->select($table, array(
	'fields' => '*',
	'conditions' => array($table.'.id' => $vars->var['id']),
	'limit' => 1
), 'default');

if (!$default) {
	redirect(path('new-db', $table));
}


//Select result
$data->register('result', $vars->getTableVars($table));

if (!$result) {
	$result = $default;
}

//Group fields by formats
$result = $data->groupFields($table, $data->valueForm($table, $result));
$default = $data->groupFields($table, $default);

//Select related tables as selects
$tmp_config_edit_db = $config_direct_relations;
$tmp_result = $default;
$tmp_table = $table;
$data_suffix = '';

include($data->load('related_as_select'));

$data->register('relate_selects', $tmp_relate_selects);

if (!$vars->var['id']) {
	return false;
}


//Select 1x x related tables
$data->register('related_result');

if ($vars->var['relate_table'] && $vars->var['relate_id']) {
	$relate_type = $data->getRelation($table, $vars->var['relate_table'], $vars->var['relate_name']);

	if ($relate_type['mode'] == 'x x' && $relate_type['relation_table'] != $data->phpcan_tables['relations']) {
		$related_result['table'] = $relate_type['relation_table']; 

		//Select default
		$related_result['default'] = $data->select($relate_type['relation_table'], array(
			'fields' => '*',
			'conditions' => array(
				$table.'.id' => $vars->var['id'],
				$vars->var['relate_table'].'.id' => $vars->var['relate_id']
			),
			'limit' => 1
		));

		//Select result
		$related_result['data'] = $vars->getTableVars($relate_type['relation_table'], '_relation');

		if (!$related_result['data']) {
			$related_result['data'] = $related_result['default'];
		}

		//Group fields
		$related_result['data'] = $data->groupFields($related_result['table'], $related_result['data']);
		$related_result['default'] = $related_result['data'];

		//Select related tables as selects
		$data->register('related_config_edit_db', $config->admin_tables[$relate_type['relation_table']]['menu-row']['edit-db']);
		$data->register('related_config_direct_relations', $config->admin_tables[$relate_type['relation_table']]['direct_relations']);

		$tmp_config_edit_db = $related_config_direct_relations;
		$tmp_result = $related_result['default'];
		$tmp_table = $relate_type['relation_table'];
		$data_suffix = '_related';

		include($data->load('related_as_select'));

		$data->register('related_relate_selects', $tmp_relate_selects);
	}
}


//Related tables
$data->register('related_tables');

foreach ((array)$config->relations[$table] as $curr_table => $relations) {
	foreach ($relations as $rel) {
		if ($rel['mode'] == '1x x' || $rel['mode'] == 'x x1') {
			continue;
		}

		$title = $rel['name'] ? $rel['name'] : $curr_table;

		if (!$relate_selects[$title]) {
			$related_tables[$title.$curr_table] = array(
				'title' => $title,
				'name' => $rel['name'],
				'table' => $curr_table,
			);
		}
	}
}
ksort($related_tables);


//Custom templates
foreach ((array)$config_edit_db['templates'] as $name => $value) {
	$templates->assingTemplate($name, $value);
}
?>
