<?php
/**
* phpCan v.1
*
* $Id: image_content.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include($data->load('validate_table'));

//Get variables
$data->register('id', $vars->int(1));

if (!$id) {
	$vars->message(__('The id of video is not valid or doesn\'t exists'), 'ko');

	return false;
}


//Configuration
$data->register('image_content_config', $config->admin_tables[$table]['menu-row']['image-content']);

if (!$image_content_config || !is_array($image_content_config)) {
	$vars->message(__('There is not configuration for this table'), 'ko');

	return false;
}

$default_config =  array(
	'image-width' => 600,
	'image-height' => 600,
	'content-width' => 200,
	'content-height' => 200,
);
$image_content_config = array_merge($default_config, $image_content_config);

$image_field = $image_content_config['image-field'];

$data->register('image_settings', $config->tables[$table][$image_field]->settings[$image_field]);
$data->register('content_table', $image_content_config['content-table']);
$data->register('relation_table', $image_content_config['relation-table']);


//Data for images
if ($vars->getController('image-content')) {
	$ok = $data->select($table, array(
		'fields' => array('id', $image_field => 'file'),
		'conditions' => array('id' => $id),
		'limit' => 1
	), 'image');

	if (!$image['file']) {
		$vars->message(__('There is not image file'), 'ko');
	}

//Data for content
} else if ($vars->getController('image-content-content')) {
	$content_table = $image_content_config['content-table'];
	$position_field = $image_content_config['relation-position'];
	$title_field = $image_content_config['content-title'];

	$data->select($content_table, array(
		'fields' => array(
			$title_field => 'title'
		),
		'addTables' => array(
			array(
				'table' => $relation_table,
				'fields' => array(
					$position_field => 'position',
				),
				'conditions' => array($table.'.id' => $id)
			)
		),
		'conditions' => array($table.'.id' => $id)
	), 'content');
}
?>
