<?php
/**
* phpCan v.1
*
* $Id: list_db.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include($data->load('validate_controller'));


$data->register('config_direct_relations', $config->admin_tables[$table]['direct_relations']);


//Choose columns to show
include_once($data->load('choose_columns_db'));


//Sort
$data->register('sort', $vars->var['sort']);
$sortdb = $sort;

if ($sort) {
	$sort = preg_replace('/(\w+) (ASC|DESC)/', '$1', $sort);
}

if (!$sort || $sort == $sortdb || !$config->tables[$table][$sort]) {
	$sort = 'id';
	$sortdb = 'id DESC';
}


//Search
$query = array();

if ($vars->var['phpcan_search']) {
	$search = new Search;

	$search_conf = array(
		'table' => $table,
		'fields' => '*',
		'text' => $vars->str('phpcan_search')
	);

	foreach ((array)$config_direct_relations as $rel) {
		$name = $rel['name'] ? $rel['name'] : $rel['table'];

		$search_conf['field_settings'][$name] = array(
			'table' => $rel['table'],
			'name' => $rel['name'],
			'field' => $rel['field'],
			'id_search' => true,
		);
	}

	$query = $search->like($search_conf);
}


//Query
$query += array(
	'fields' => $fields,
	'limit' => 15,
	'sort' => $sortdb,
	'conditions' => $search,
	'pagination' => array(
		'page' => $vars->int('page'),
		'map' => 10
	)
);


//Select
$data->select($table, $query, 'listing');
?>