<?php
/**
* phpCan v.1
*
* $Id: menu.php 195 2009-06-25 21:00:16Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

if (!$session->isInstalled()) {
	return true;
}

include_once ($config->paths['scene-config'].'admin_menu_extra_options.php');

$table = $data->tableExists($vars->var[0]);
$extra_options = $menu_extra_options[$vars->getController()];

//Scene
$data->register('menu_scenes');

$url = '';
$menu_scenes = array();

foreach ($config->scenes as $scene => $value) {
	$url = $config->paths['www'].$scene.'/admin/';
	$menu_scenes[] = array(
		'url' => $url,
		'name' => $scene,
		'selected' => $scene == $vars->getScene() ? true : false
	);
}

sort($menu_scenes);

//Menu
$data->register('menu');

if ($table && $config->admin_tables[$table]['menu']) {
	$menu = $config->admin_tables[$table]['menu'];
} else if ($extra_options) {
	$menu = $extra_options['menu'];
} else {
	$menu = $vars->getController();
}

//Submenu
$data->register('submenu');

$controller = '';
$submenu = array();

foreach ($config->admin_tables as $key => $value) {
	if (($value['menu'] != $menu) || !in_array($key, (array)$session->user['tables'])) {
		continue;
	}

	if ($key == $table) {
		$submenu[$key]['selec'] = true;
	}

	foreach ($value['menu-table'] as $k => $v) {
		$controller = is_array($v) ? $k : $v;

		if (!in_array($key, $session->user['permissions']['controllers'][$controller])) {
			continue;
		}

		$submenu[$key]['controllers'][$controller] = $vars->getController() == $controller && $key == $table ? true : false;
		$submenu[$key]['var0'] = $key;
	}
}

$seccion = '';

//Extra options
foreach ((array)$menu_extra_options as $key => $value) {
	if (($value['menu'] != $menu) || !in_array($key, (array)$session->user['permissions']['extra'])) {
		continue;
	}

	$section = $value['submenu'];

	if ($vars->getController() == $key) {
		$submenu[$section]['selec'] = true;
	}

	$submenu[$section]['controllers'][$key] = $key == $vars->getController() ? true : false;
	$submenu[$section]['var0'] = '';
}

//Row menu
if ($table && is_array($config->admin_tables[$table]['menu-row'])) {
	$data->register('row_menu');

	foreach ($config->admin_tables[$table]['menu-row'] as $k => $v) {
		$controller = is_array($v) ? $k : $v;
		$row_menu[$controller] = $controller;
	}
}


//Page title
$data->register('page_title');

$page_title = __($vars->getController()).' '.format($vars->var[0]);


//Saved pages
$admin_table = $data->tableExists('admin');

$data->select($admin_table, array(
	'fields' => '*',
	'conditions' => array(
		'user' => $session->user['user'],
		'type' => 'saved-pages'
	),
	'order' => 'name'
), 'saved_pages');

$data->register('page_is_saved');
$page_is_saved = $data->selectCount($admin_table, array(
	'conditions' => array(
		'user' => $session->user['user'],
		'type' => 'saved-pages',
		'value' => path()
	)
));
?>
