<?php
/**
* phpCan v.1
*
* $Id: related_db.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include($data->load('validate_table'));

$data->register('sort', $vars->var['sort']);
$data->register('relation', array(
	'table' => $table,
	'id' => $vars->var[1],
	'name' => $vars->var[3],
	'title' => $vars->var[3] ? $vars->var[3] : $table
));
$table = $vars->var[2];

if (empty($config->tables[$table])) {
	$vars->message(__('The relation table doesn\'t exists'), 'ko');

	return false;
}

if (!$rel = $data->getRelation($table, $relation['table'], $relation['name'])) {
	$vars->message(__('This relation don\'t exists'), 'ko');

	return false;
} else {
	$relation['mode'] = $rel['mode'];
}

//Choose columns to show
include_once($config->paths['data'].'choose_columns_db.php');

//Sort
$sortdb = $sort;

if ($sort) {
	$sort = preg_replace('/(\w+) (ASC|DESC)/', '$1', $sort);
}

if (!$sort || $sort == $sortdb || !$config->tables[$table][$sort]) {
	$sort = 'id';
	$sortdb = 'id DESC';
}

$options = array(
	'fields' => $fields,
	'sort' => $sortdb
);

if ($vars->var['show_all']) {
	$options['addTables'][] = array(
		'table' => $relation['table'],
		'fields' => array('id'),
		'relation_name' => $relation['name'],
		'conditions' => array(
			'id' => $relation['id']
		),
		'limit' => 1
	);
} else {
	$options['conditions'] = array(
		$relation['table'].'.id('.$relation['name'].')' => $relation['id']
	);
	$options['addTables'][] = array(
		'table' => $relation['table'],
		'fields' => array('id'),
		'relation_name' => $relation['name'],
		'limit' => 1
	);
}

if ($vars->var['phpcan_search']) {
	$search = new Search;
	
	$options += $search->like(array(
		'table' => $table,
		'fields' => '*',
		'text' => $vars->str('phpcan_search')
	));
}

$options['pagination'] = array(
	'page' => $vars->var['page'],
	'map' => 10
);

//Select listing
$data->select($table, $options, 'listing');
?>