<?php
/**
* phpCan v.1
*
* $Id: users.php 197 2009-06-29 18:44:58Z eordes $
*
* 2009 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include($data->load('validate_menu_extra'));

$admin_table = $data->tableExists('admin');

$data->select($admin_table, array(
	'fields' => array('user'),
	'group' => 'user',
), 'users');

if ($vars->var[0]) {
	$data->select($admin_table, array(
		'fields' => '*',
		'conditions' => array(
			'user' => $vars->str(0)
		)
	), 'current_user');
}

$user = array();

if ($current_user) {
	$user['user'] = $vars->str(0);

	foreach ($current_user as $row) {
		$user[$row['name']] = $row['value'];
	}

	$current_user = $user;
	$current_user['controllers'] = (array)unserialize($user['controllers']);
	$current_user['extra'] = (array)unserialize($user['extra']);
	$current_user['actions'] = (array)unserialize($user['actions']);
	$current_user['table_actions'] = (array)unserialize($user['table_actions']);

	unset($user);
} else {
	$current_user = array(
		'controllers' => array(),
		'extra' => array(),
		'actions' => array(),
		'table_actions' => array()
	);
}

$controllers = array();

foreach ($config->admin_tables as $table => $options) {
	if (is_array($options['menu-table'])) {
		foreach ($options['menu-table'] as $each) {
			$controllers[$each][] = $table;
		}
	} else if ($options['menu-table']) {
		$controllers[$options['menu-table']][] = $table;
	}

	if (is_array($options['menu-row'])) {
		foreach ($options['menu-row'] as $key => $each) {
			if (is_array($each)) {
				$controllers[$key][] = $table;
			} else {
				$controllers[$each][] = $table;
			}
		}
	} else if ($options['menu-row']) {
		$controllers[$options['menu-row']][] = $table;
	}
}

$table_actions = array();

foreach ($controllers as $tables) {
	foreach ($tables as $table) {
		foreach ($config->actions as $action => $options) {
			if (($options['type'] == 'table') && (!is_array($table_actions[$action]) || !in_array($table, $table_actions[$action]))) {
				$table_actions[$action][] = $table;
			}
		}
	}
}
?>
