<?php
/**
* phpCan v.1
*
* $Id: video_content.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include($data->load('validate_table'));


//Get variables
$data->register('id', $vars->int(1));

if (!$id) {
	$vars->message(__('The id of video is not valid or doesn\'t exists'), 'ko');

	return false;
}


//Configuration
$data->register('video_content_config', $config->admin_tables[$table]['menu-row']['video-content']);

if (!$video_content_config || !is_array($video_content_config)) {
	$vars->message(__('There is not configuration for this table'), 'ko');

	return false;
}

$video_field = $video_content_config['video-field'];

$data->register('video_settings', $config->tables[$table][$video_field]->settings[$video_field]);
$data->register('content_table', $video_content_config['content-table']);


//Data for video
if ($vars->getController('video-content')) {
	$total = $data->select($table, array(
		'fields' => array('id', $video_field => 'file'),
		'conditions' => array('id' => $id),
		'limit' => 1
	), 'video');

	if (!$video['file']) {
		$vars->message(__('There is not video file'), 'ko');
	}
	
	$data->register('video_size', array('width' => $video_content_config['video-width'], 'height' => $video_content_config['video-height']));


//Data for content
} else if ($vars->getController('video-content-content')) {
	$time_field = $video_content_config['time-field'];
	$position_field = $video_content_config['position-field'];
	$text_field = $video_content_config['text-field'];

	$total = $data->select($content_table, array(
		'fields' => array(
			$time_field => 'time',
			$text_field => 'text',
			$position_field => 'position'
		),
		'conditions' => array($table.'.id' => $id),
		'order' => $time_field.'_start'
	), 'content');
}
?>
