<?php
/**
* phpCan v.1
*
* $Id$
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

class Users {
	public function install () {
		global $data, $config, $debug;

		$user = 'admin';
		$pass = md5('phpcan');
		$controllers = $actions = $extra = $table_actions = array();

		foreach ($config->admin_tables as $table => $options) {
			if (is_array($options['menu-table'])) {
				foreach ($options['menu-table'] as $each) {
					$controllers[$each][] = $table;
				}
			} else if ($options['menu-table']) {
				$controllers[$options['menu-table']][] = $table;
			}

			if (is_array($options['menu-row'])) {
				foreach ($options['menu-row'] as $key => $each) {
					if (is_array($each)) {
						$controllers[$key][] = $table;
					} else {
						$controllers[$each][] = $table;
					}
				}
			} else if ($options['menu-row']) {
				$controllers[$options['menu-row']][] = $table;
			}
		}

		foreach ($controllers as $each) {
			foreach ($each as $table) {
				foreach ($config->actions as $action => $options) {
					if (($options['type'] == 'table') && (!is_array($table_actions[$action]) || !in_array($table, $table_actions[$action]))) {
						$table_actions[$action][] = $table;
					}
				}
			}
		}

		$actions = array();

		foreach ($config->actions as $action => $options) {
			if ($options['type'] != 'table') {
				$actions[] = $action;
			}
		}

		global $menu_extra_options;

		if (!is_array($menu_extra_options)) {
			include_once ($config->paths['scene-config'].'admin_menu_extra_options.php');
		}

		$extra = array_keys($menu_extra_options);

		$data->save($data->tableExists('admin'), array(
			'insert' => array(
				'data' => array(
					array(
						'type' => 'preferences',
						'name' => 'password',
						'value' => $pass,
						'user' => $user
					),
					array(
						'type' => 'preferences',
						'name' => 'enabled',
						'value' => 1,
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'controllers',
						'value' => serialize($controllers),
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'extra',
						'value' => serialize($extra),
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'actions',
						'value' => serialize($actions),
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'table_actions',
						'value' => serialize($table_actions),
						'user' => $user
					)
				)
			)
		));
	}

	public function add () {
		global $vars, $data, $config, $debug;

		$table = $data->tableExists('admin');
		$user = $vars->str('user');

		if (strlen($user) < 4) {
			$vars->message(__('Username must be 4 characters at least'), 'ko');
			return false;
		}

		$data->select($table, array(
			'fields' => 'id',
			'conditions' => array(
				'user' => $user
			)
		), 'exists');

		if ($exists) {
			$vars->message(__('User %s already exists.', $user), 'ko');
			return false;
		}

		if (strlen($vars->var['new_password']) < 6) {
			$vars->message(__('Password must be 6 characters at least'), 'ko');
			return false;
		}

		if ($vars->var['new_password'] != $vars->var['new_password_repeat']) {
			$vars->message(__('Password and repeat password are different'), 'ko');
			return false;
		}

		$data->save($table, array(
			'insert' => array(
				'data' => array(
					array(
						'type' => 'preferences',
						'name' => 'password',
						'value' => md5($vars->var['new_password']),
						'user' => $user
					),
					array(
						'type' => 'preferences',
						'name' => 'enabled',
						'value' => intval($vars->var['enabled']),
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'controllers',
						'value' => serialize($vars->var['controllers']),
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'extra',
						'value' => serialize($vars->var['extra']),
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'actions',
						'value' => serialize($vars->var['actions']),
						'user' => $user
					),
					array(
						'type' => 'permissions',
						'name' => 'table_actions',
						'value' => serialize($vars->var['table_actions']),
						'user' => $user
					)
				)
			)
		));

		return true;
	}

	public function edit () {
		global $vars, $data, $config, $debug;

		$table = $data->phpcan_tables['admin'];
		$user = $vars->str('user');

		if (strlen($user) < 4) {
			$vars->message(__('Username must be 4 characters at least'), 'ko');
			return false;
		}

		if ($vars->var['new_password'] && (strlen($vars->var['new_password']) < 6)) {
			$vars->message(__('Password must be 6 characters at least'), 'ko');
			return false;
		}

		if ($vars->var['new_password'] != $vars->var['new_password_repeat']) {
			$vars->message(__('Password and repeat password are different'), 'ko');
			return false;
		}

		if ($user != $vars->var['old_user']) {
			$exists = $data->select($table, array(
				'data' => 'id',
				'conditions' => array(
					'user' => $user
				)
			));

			if ($exists) {
				$vars->message(__('User %s already exists.', $user), 'ko');
				return false;
			} else {
				$data->save($table, array(
					'update' => array(
						'data' => array(
							'user' => $user
						),
						'conditions' => array(
							'user' => $vars->str('old_user')
						)
					)
				));
			}
		}

		$userdata = $data->select($table, array(
			'fields' => array('id', 'name'),
			'conditions' => array(
				'user' => $user
			)
		));

		$ids = array();

		foreach ($userdata as $row) {
			$ids[$row['name']] = $row['id'];
		}

		if ($vars->var['new_password']) {
			$data->save($table, array(
				'update' => array(
					'data' => array(
						'value' => md5($vars->var['new_password'])
					),
					'conditions' => array(
						'user' => $user,
						'name' => 'password',
						'type' => 'preferences'
					)
				)
			));
		}

		return $data->save($table, array(
			'replace' => array(
				'data' => array(
					array(
						'id' => $ids['enabled'],
						'type' => 'preferences',
						'name' => 'enabled',
						'value' => intval($vars->var['enabled']),
						'user' => $user
					),
					array(
						'id' => $ids['controllers'],
						'type' => 'permissions',
						'name' => 'controllers',
						'value' => serialize($vars->var['controllers']),
						'user' => $user
					),
					array(
						'id' => $ids['extra'],
						'type' => 'permissions',
						'name' => 'extra',
						'value' => serialize($vars->var['extra']),
						'user' => $user
					),
					array(
						'id' => $ids['actions'],
						'type' => 'permissions',
						'name' => 'actions',
						'value' => serialize($vars->var['actions']),
						'user' => $user
					),
					array(
						'id' => $ids['table_actions'],
						'type' => 'permissions',
						'name' => 'table_actions',
						'value' => serialize($vars->var['table_actions']),
						'user' => $user
					)
				)
			)
		));
	}
}

$users = new Users;
?>
