<?php
/**
* phpCan v.1
*
* $Id: content-user.php 198 2009-06-29 18:46:15Z eordes $
* 
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();
?>

<script type="text/javascript">
$(document).ready(function () {
	$("input.password").val("");

	$('input[name="checkall_controllers"]').click(function () {
		var check = $(this).attr('checked');

		$('#table_controllers input').attr('checked', check);
	});

	$('th[id^="controller_"]').click(function () {
		var controller = $(this).attr('id').replace(/^controller_/, '');

		$('td[id$="_'+controller+'"] input').each(function () {
			if ($(this).attr('checked')) {
				$(this).attr('checked', false);
			} else {
				$(this).attr('checked', true);
			}
		});
	});

	$('th[id^="table_"]').click(function () {
		var table = $(this).attr('id').replace(/^table_/, '');

		$('td[id^="'+table+'_"] input').each(function () {
			if ($(this).attr('checked')) {
				$(this).attr('checked', false);
			} else {
				$(this).attr('checked', true);
			}
		});
	});
});
</script>

<div class="row t1 b2">
	<div class="block con3">
		<h3><?php __e('List of users'); ?></h3>
		<ul>
			<?php foreach ($users as $user) { ?>
			<li><?php echo $html->a($user['user'], path(true, $user['user'])); ?></li>
			<?php } ?>
		</ul>
	</div>
	
	<div class="col7 last">
		<h3>
		<?php
		if ($current_user['user']) {
			__e('Edit user %s', $current_user['user']);
		} else {
			__e('New User');
		}
		?>
		</h3>

		<form id="user_admin" action="<?php echo path(); ?>" method="post" class="t1 col7 last">
			<fieldset class="inline">
			<?php
			echo $html->formHidden($current_user['user'], 'old_user');
			echo $html->formHidden('1', 'phpcan_action[save-user]');

			echo $html->formText(array(
				'value' => $current_user['user'],
				'variable' => 'user',
				'class' => 'col5 last'
			), array(
				'text' => __('User'),
				'class' => 'col2 normal'
			));

			echo $html->formPassword(array(
				'name' => 'new_password',
				'class' => 'col5 last'
			), array(
				'text' => __('New password'),
				'class' => 'col2 normal'
			));
			echo $html->formPassword(array(
				'name' => 'new_password_repeat',
				'class' => 'col5 last'
			), array(
				'text' => __('Repeat new password'),
				'class' => 'col2 normal'
			));

			echo $html->formCheckbox(array(
				'name' => 'enabled',
				'value' => 1,
				'checked' => $current_user['enabled'],
				'force' => true
			), array(
				'text' => __('Enabled'),
				'class' => 'col2 normal'
			));
			?>

			<hr />
			<h3 class="t4"><label><?php __e('Controllers'); ?> <input type="checkbox" name="checkall_controllers" value="" title="<?php __e('Check all controllers'); ?>" /></label></h3>

			<table id="table_controllers" class="default">
				<thead>
					<tr>
						<th class="title"><?php __e('Table'); ?></th>
						<?php
						foreach (array_keys($controllers) as $controller) {
							echo '<th class="centered" id="controller_'.$controller.'">'.__($controller).'</th>';
						}

						foreach (array_keys($table_actions) as $action) {
							echo '<th class="centered" id="controller_'.$action.'">'.__($action).'</th>';
						}
						?>
					</tr>
				</thead>
				<tbody>
					<?php
					foreach ($config->tables as $table => $fields) {
						if (in_array($table, $data->phpcan_tables)) {
							continue;
						}
					?>
					<tr>
						<th id="table_<?php echo $table; ?>"><?php echo $table; ?></td>
						<?php
						foreach ($controllers as $controller => $tables) {
							echo '<td class="centered" id="'.$table.'_'.$controller.'">';

							if (true || in_array($table, $tables)) {
								echo $html->formCheckbox(
									array(
										'id' => 'controllers_'.$table.'_'.$controller,
										'name' => 'controllers['.$controller.'][]',
										'value' => $table,
										'checked' => in_array($table, (array)$current_user['controllers'][$controller]),
										'force' => true
									)
								);
							} else {
								echo '&nbsp;';
							}

							echo '</td>';
						}

						foreach ($table_actions as $action => $tables) {
							echo '<td class="centered" id="'.$table.'_'.$action.'">';

							if (true || in_array($table, $tables)) {
								echo $html->formCheckbox(
									array(
										'id' => 'table_actions_'.$table.'_'.$action,
										'name' => 'table_actions['.$action.'][]',
										'value' => $table,
										'checked' => in_array($table, (array)$current_user['table_actions'][$action]),
										'force' => true
									)
								);
							} else {
								echo '&nbsp;';
							}

							echo '</td>';
						}

						?>
					</tr>
					<?php } ?>
				</tbody>
			</table>

			<hr />
			<h3 class="t4"><?php __e('Menu extra utils'); ?></h3>

			<table class="default">
				<thead>
					<tr>
						<th class="title"><?php __e('Option'); ?></th>
						<th class="title centered"><?php __e('Enabled'); ?></th>
					</tr>
				</thead>
				<tbody>
					<?php foreach ($menu_extra_options as $name => $options) { ?>
					<tr>
						<td><label for="extra_<?php echo $name; ?>"><?php echo $name; ?></label></td>
						<td class="centered">
						<?php
						if (($name != 'users') || ($current_user['user'] != $session->user['user'])) {
							echo $html->formCheckbox(
								array(
									'id' => 'extra_'.$name,
									'name' => 'extra[]',
									'value' => $name,
									'checked' => in_array($name, (array)$current_user['extra']),
									'force' => true
								)
							);
						} else {
							echo $html->formHidden('users', 'extra[]');
						}
						?>
						</td>
					</tr>
					<?php } ?>
				</tbody>
			</table>

			<hr />
			<h3 class="t4"><?php __e('Actions'); ?></h3>

			<table class="default">
				<thead>
					<tr>
						<th class="title"><?php __e('Action'); ?></th>
						<th class="title centered"><?php __e('Enabled'); ?></th>
					</tr>
				</thead>
				<tbody>
					<?php
					foreach ($config->actions as $action => $options) {
						if (empty($options['type']) || ($options['type'] == 'table')) {
							continue;
						}
					?>
					<tr>
						<td><label for="actions_<?php echo $action; ?>"><?php echo $action; ?></label></td>
						<td class="centered">
						<?php
						if (($action != 'save-user') || ($current_user['user'] != $session->user['user'])) {
							echo $html->formCheckbox(
								array(
									'id' => 'actions_'.$action,
									'name' => 'actions[]',
									'value' => $action,
									'checked' => in_array($action, (array)$current_user['actions']),
									'force' => true
								)
							);
						} else {
							echo $html->formHidden('save-user', 'actions[]');
						}
						?>
						</td>
					</tr>
					<?php } ?>
				</tbody>
			</table>

			<?php
			echo $html->formSubmit(array(
				'value' => __('Save'),
				'name' => 'phpcan_action[save-user]',
				'id' => 'submit_save'
			));

			if ($current_user['user']) {
				echo $html->formSubmit(array(
					'value' => __('Delete'),
					'name' => 'phpcan_action[delete_user]',
					'id' => 'submit_delete',
					'onclick' => "return submitConfirm('".__('This user will be deleted. Are you sure?')."', '".path('users')."');"
				));
			}
			?>
			</fieldset>
		</form>
	</div>
</div>
