<?php
/**
* phpCan v.1
*
* $Id: gmaps-edit-db.php 351 2009-07-23 20:17:53Z oscar $
* 
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

global $config, $html;

$x = $info['name'].'_x';
$y = $info['name'].'_y';
$z = $info['name'].'_z';
?>

<div class="row t1">
	<label for="<?php echo $info['name'].$info['suffix']; ?>" class="col2">
		<?php echo format(__($info['name'])); ?>
	</label>
	
	<div class="col8 last">
		<div id="<?php echo $info['name'].$info['suffix']; ?>" class="col6" style="height: 300px"></div>
		
		<div class="col2 last">
		<?php
		echo $html->formText(array(
				'value' => $info['value'][$y],
				'name' => $y.$info['suffix'],
				'id' => $y.$info['suffix'],
				'class' => 'col2',
				'overwrite_control' => $info['default'][$y],
				'error' => $info['error']['y']
			),
			array(
				'text' => __('Latitude'),
				'class' => 'col2 sub-label',
			)
		);
		
		echo $html->formText(array(
				'value' => $info['value'][$x],
				'name' => $x.$info['suffix'],
				'id' => $x.$info['suffix'],
				'class' => 'col2',
				'overwrite_control' => $info['default'][$x],
				'error' => $info['error']['x']
			),
			array(
				'text' => __('Longitude'),
				'class' => 'col2 sub-label',
			)
		);
		
		echo $html->formText(array(
				'value' => $info['value'][$z],
				'name' => $z.$info['suffix'],
				'id' => $z.$info['suffix'],
				'class' => 'col1',
				'overwrite_control' => $info['default'][$z],
				'error' => $info['error']['z']
			),
			array(
				'text' => __('Zoom'),
				'class' => 'col2 sub-label',
			)
		);
		
		echo $html->formText(array(
				'id' => 'search_'.$info['name'].$info['suffix'],
				'class' => 'col2',
			),
			array(
				'text' => __('Search'),
				'class' => 'col2 t6 sub-label',
			)
		);
		?>
		</div>
	</div>

	<?php
	echo $html->jsLink('../formats/common/jquery.jmap/jquery.jmap.js');
	echo $html->jsLink('/maps?file=api&amp;v=2&amp;sensor=false&amp;key='.$config->base['gmap_key'], 'http://maps.google.com');
	?>

	<script type="text/javascript">
		$(document).ready(function() {
			
			<?php
			$x .= $info['suffix'];
			$y .= $info['suffix'];
			$z .= $info['suffix'];
			
			echo 'rules.'.$z.' = '.array2json(
				array(
					'required' => true,
					'min' => 1,
					'max' => 17
				)
			);
			?>;
			
			$('#<?php echo $x; ?>, #<?php echo $y; ?>, #<?php echo $z; ?>').keydown(function (event) {
				if (event.keyCode == 13) {
					$('#<?php echo $x; ?>').change();
					return false;
				}
			});
			
			$("div#<?php echo $info['name'].$info['suffix']; ?>").jmap('init', {
				'mapType': 'hybrid',
				'mapCenter': [<?php echo $info['value'][$y]; ?>,<?php echo $info['value'][$x]; ?>],
				'mapZoom': <?php echo $info['value'][$z]; ?>
			},
			function (map, element, options) {
				
				$("div#<?php echo $info['name']; ?>").jmap('AddMarker', {
          'pointLatLng': ['<?php echo $info['value'][$y]; ?>','<?php echo $info['value'][$x]; ?>'],
					'pointIsDraggable': true
				},
				function (marker, element, options) {
					GEvent.addListener(marker, 'dragend', function (latlng) {
						$('#<?php echo $x; ?>').val(latlng.x);
						$('#<?php echo $y; ?>').val(latlng.y);
					});
					
					GEvent.addListener(map, 'zoomend', function (oldLevel, newLevel) {
						$('#<?php echo $z; ?>').val(newLevel);
					});
					
					GEvent.addListener(map, 'dblclick', function (overlay, latlng) {
						marker.setPoint(new GLatLng(latlng.y, latlng.x));
					});
					
					$('#<?php echo $x; ?>, #<?php echo $y; ?>, #<?php echo $z; ?>').change(function () {
						var x = parseFloat($('#<?php echo $x; ?>').val());
						var y = parseFloat($('#<?php echo $y; ?>').val());
						var z = parseInt($('#<?php echo $z; ?>').val());
						if (z < 1 || z > 16) {
							return false;
						}
						marker.setPoint(new GLatLng(y, x));
						map.setCenter(new GLatLng(y, x), z);
					});
					
					$('#<?php echo 'search_'.$info['name'].$info['suffix']; ?>').keypress(function (e) {
						if (e.which == 13) {
							$("div#<?php echo $info['name']; ?>").jmap('SearchAddress', {
								'query': $(this).val(),
								'returnType': 'getLocations'
							}, function (result, options) {
								var valid = Mapifies.SearchCode(result.Status.code);

								if (valid.success) {
									$.each(result.Placemark, function (i, point) {
										$('#<?php echo $x; ?>').val(point.Point.coordinates[0]);
										$('#<?php echo $y; ?>').val(point.Point.coordinates[1]);

										$('#<?php echo $x; ?>').change();
										$('#<?php echo $y; ?>').change();
									});
								} else {
									alert(valid.message);
								}
							});

							return false;
						}
					});
				});
			});
		});
	</script>
</div>
