<?php
/**
* phpCan v.1
*
* $Id: image-edit-db.php 194 2009-06-25 16:19:56Z eordes $
* 
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

global $html;

$thumb = new Thumb;

$settings = $info['object']->settings[$info['name']];
$validate = array();

if ($settings['required']) {
	$validate['required'] = true;
}

$validate['accept'] = implode('|', $settings['valid_extensions']);
?>

<div class="row t1">
	<label for="<?php echo $info['name'].$info['suffix']; ?>" class="col2">
		<?php echo format(__($info['name'])); ?>
	</label>
	
	<div class="col8 last">
	
		<?php if ($info['value']) { ?>
		<div class="col2">
			<?php echo $html->img(array(
				'src' => $thumb->liveSrc($info['value'], 150, 150),
				'class' => 'thumb',
				'id' => 'thumb_'.$info['name'].$info['suffix'],
				'longdesc' => $settings['www-media_dir'].$info['value'],
			)); ?>
		</div>
		<?php } ?>
		
		<div class="col6 last">
			<?php
			echo $html->formFile(array(
				'id' => $info['name'].$info['suffix'],
				'name' => $info['name'].$info['suffix'],
				'overwrite_control' => $info['default'],
				'error' => $info['error']
			));
			?>
			
			<?php if ($info['value']) { ?>
			<p class="row t1">
				<?php
				echo $html->a(array(
					'text' => __('View original'),
					'href' => $settings['www-media_dir'].$info['value'],
					'class' => 'button',
					'target' => 'blank'
				));
				echo ' ';
				echo $html->a(array(
					'text' => __('Crop'),
					'rel' => 'thumb_'.$info['name'].$info['suffix'],
					'class' => 'button2 format-image-crop',
					'href' => path().get(array(
						'src' => $settings['media_dir'].$info['value'],
						'phpcan_action[image_transform]' => 1
					))
				));
				?>
			</p>
			<?php } ?>
		</div>
	</div>

	<script type="text/javascript">
		<?php echo 'rules.'.$info['name'].$info['suffix'].' = '.array2json($validate); ?>
	</script>

	<?php
	echo $html->jsLink('../formats/image/js/image-edit.js');
	echo $html->jsLink('../formats/common/jquery.jcrop/jquery.Jcrop.min.js');
	echo $html->dinamicCssLink('../formats/common/jquery.jcrop/css/jquery.Jcrop.css');
	?>
</div>