$(document).ready(function () {

	$('#image-content').live('submit', function () {
		$(this).ajaxSubmit({
			success: function (data) {
				$('#image_content_content').html(data);
				message_effect('#image_content_content');
			}
		});

		return false;
	});
});

$(window).load(load_content);

function load_content () {
	var url = $('#image_content_content').attr('rel');
	$('#image_content_content').load(url, update_position_divs);
}

var image_width = 0;
var image_height = 0;
var image_top = 0;
var image_left = 0;

function percent2px (x, y) {
	x = ((x * image_width)/100) - (size_w / 2);
	y = ((y * image_height)/100) - (size_h / 2);

	return {'x': x, 'y': y};
}

function px2percent (x, y) {
	y = (y - image_top) + (size_h / 2);
	x = (x - image_left) + (size_w /2);
	y = Math.round((y * 100) / image_height);
	x = Math.round((x * 100) / image_width);

	return {'x': x, 'y': y};
}

//Update divs
function update_position_divs () {
	$('.div_content').remove();

	var image = $('#image_content img');
	var position = $(image).offset();

	image_width = $(image).width();
	image_height = $(image).height();
	image_top = position.top;
	image_left = position.left;

	var num = 1;

	$('#image-content fieldset').each(function () {
		var x = parseInt($('input[name^=position_x]', this).val());
		var y = parseInt($('input[name^=position_y]', this).val());
		var title = $('p', this).html();

		var pos = percent2px(x, y);

		$('#image_content').prepend('<div class="div_content" rel="' + num + '">' + title + '</div>');
		$('#image_content .div_content[rel=' + num + ']').css({
			'margin-left': pos.x + 'px',
			'margin-top': pos.y + 'px',
			'width': size_w + 'px',
			'height': size_h + 'px'
		});

		num++;
	});
	
	update_drop_event();
}

//Add drop event
function update_drop_event () {
	$('.div_content').draggable({
		containment: '#image_content img',
		stop: function () {
			var num = $(this).attr('rel');
			var position = $(this).offset();
			var pos = px2percent (position.left, position.top)

			$('input[name=position_x\[' + num + '\]]').val(pos.x);
			$('input[name=position_y\[' + num + '\]]').val(pos.y);
		}
	});
}