$(document).ready(function () {

	//Show/hide relations
	$('div.label-related a[rel=relation]').click(function () {
		var div = $(this).parents('.content-related');
		var content = $('.content', div);
		var href = $(this).attr('href');
		
		if ($(content).is(':hidden')) {
			$('div.filter', div).slideDown('normal');

			if (!$(content).html()) {
				$(div).css('cursor', 'wait');

				$(content).load(href, function () {
					$(content).slideDown('normal');
					$(div).css('cursor', 'default');
				});
			} else {
				$(content).slideDown('normal');
			}

		} else {
			$(content).slideUp('normal');
			$('div.filter', div).slideUp('normal');
		}

		return false;
	});
	
	//Show all/Show filtered
	$('div.label-related a[rel=show_all]').click(function () {
		var div = $(this).parents('.content-related');
		var content = $('.content', div);
		var href = $(this).attr('href');
		
		if ($(this).hasClass('select')) {
			var get_index = href.indexOf('?');

			if (get_index != -1) {
				href = href.substring(0, get_index);
			}
			
			$(this).removeClass('select');
		} else {
			$(this).addClass('select');
		}

		$(content).slideUp('normal', function () {
			$(this).load(href, function () {
				$(this).slideDown('fast');
			});
		});

		return false;
	});
	
	//Search focus/blur
	$('.related_search .text').focus(function () {
		var text = $(this).val();
		if (text == this.defaultValue) {
			$(this).val('');
		}
	});
	$('.related_search .text').blur(function () {
		var text = $.trim($(this).val());
		if (!text) {
			$(this).val(this.defaultValue);
		}
	});
	
	//Search submit
	$('.related_search').submit(function () {
		var div = $(this).parents('.content-related');
		var content = $('.content', div);
		var input = $('.text', this);

		$(this).ajaxSubmit({
			'success': function (data) {
				$(content).html(data);
				$('a[rel=show_all]', div).addClass('select');
				$(input).val(input[0].defaultValue);
				input[0].blur();
			}
		});

		return false;
	});
	
	
	//Relate columns preferences
	$('div.content-related th.pref_cols form').live('submit', function () {
		var div = $(this).parents('.content');

		$(this).ajaxSubmit({
			'success': function (data) {
				$(div).html(data);
			}
		});

		return false;
	});
	
	//Show/hide the columns preferences
	$('th.pref_cols .columns a').live('click', function () {
		var th = $(this).parents('th.pref_cols');
		var form = $('form', th);

		if ($(form).is(':hidden')) {
			$(form).show();
		} else {
			$(form).hide();
		}
		return false;
	});
	
	
	//Related links
	$('.content-related .content a[rel!=newwindow]').live('click', function () {
		var div = $(this).parents('.content');

		$(div).load($(this).attr('href'));

		return false;
	});
	
	
	//Relate-unrelate
	$('form.relate_db').live('submit', function () {
		var data = $(this).serialize();
		var url = $(this).attr('action');
		var submit = $(':submit', this);
		var action = $(':hidden[name=action]', this).val();
		var tr = $(this).parents('tr');
		var text_submit = $(submit).val();
		var div = $(this).parents('.content');

		if (action == 'relate') {
			$(tr).addClass('related');
			$(':hidden[name=action]', this).val('unrelate');
		} else {
			if ($(div).data('mode') == 'relation') {
				$(tr).fadeOut('slow');
			} else {
				$(tr).removeClass('related');
				$(':hidden[name=action]', this).val('relate');
			}
		}
		
		$.get(url, data, function (data) {
			if (data) {
				$(submit).val(data);
				if (relation_mode == '1 x' || relation_mode == '1 1') {
					$(tr).data('current', 1);
					$('tr.related').each(function () {
						if ($(this).data('current') == 1) {
							$(this).removeData('current');
						} else {
							$(this).removeClass('related');
							$('.relate_db :hidden[name=action]', this).val('relate');
							$('.relate_db :submit', this).val(text_submit);
						}
					});
				}
			} else {
				if (action == 'unrelate') {
					$(tr).addClass('related');
					$(':hidden[name=action]', this).val('unrelate');
				} else {
					$(tr).removeClass('related');
					$(':hidden[name=action]', this).val('relate');
				}
			}
		});
		
		return false;
	});
});


//Create new relation
function save_relate_db (object) {
	var div = $(object).parents('.content-related');

	update_relate (object);

	$('.label-related a.select', div).removeClass('select');
}

//Update after close modal
function update_relate (object) {
	var div = $(object).parents('.content-related');
	var url = $('.label-related a[rel=relation]', div).attr('href');
	var content = $('.content', div);

	$(content).load(url);
}