$(document).ready(function () {

	message_effect ();

	//Menu
	$('#sections-menu a').click(function () {
		var submenu = $(this).parent().attr('id') + '-controller';
		$('#sections-menu li').removeClass('now');
		$(this).parent().addClass('now');
		
		if ($(this).parent().hasClass('current')) {
			$('#controllers-menu').removeClass('now');
		} else {
			$('#controllers-menu').addClass('now');
		}
		$('#controllers-menu ul').hide();
		$('#controllers-menu ul#' + submenu).show();
		return false;
	});
	
	//Scene menu
	$('select#scene_menu').change(function () {
		location.href = $(this).val();
	});
	
	//Go to save page
	$('select#saved_pages').change(function () {
		if ($(this).val()) {
			location.href = $(this).val();
		}
	});
	
	//Save page
	$('a#save_page').click(function () {
		var link = this;
		$.get($(this).attr('href'), function (data) {
			$(link).fadeOut('slow');
		});
		return false;
	});
	
	//Delete saved pages
	$('ul#list_saved_pages li').mouseover(function () {
		$('.hide', this).show();
		$('a', this).addClass('select');
	});
	$('ul#list_saved_pages li').mouseout(function () {
		$('.hide', this).hide();
		$('a', this).removeClass('select');
	});

	$('ul#list_saved_pages .delete').click(function () {
		var li = $(this).parent();

		$.post($(this).attr('href'), function (data) {
			$(li).fadeOut('slow');
		});
		return false;
	});
	
	//Rename saved pages
	$('ul#list_saved_pages .rename').click(function () {
		var li = $(this).parent();
		var link = $('a:last-child', li);
		var new_name = prompt('New name', $(link).html());
		new_name = $.trim(new_name);
		
		if (new_name) {
			var vars = $(this).attr('href') + '&title=' + new_name;
			$.post(vars, function (data) {
				$(link).html(new_name);
			});
		}
		return false;
	});
	
	
	
	//Modal
	$('a[target=modal], #modal-content a[target!=none]').live('click', function (event) {
		if (event.button != 0) {
			return true;
		}

		if ($(this).attr('id') == 'modal-close') {
			hide_modal();
			return false;
		}

		var href = $(this).attr('href');
		var fn = $(this).attr('rel');
		var link = $(this);

		$.post(href, function (data) {
			$('#modal-content').html(data);
			show_modal();

			$('#modal-close').one('click', function () {
				if (typeof fn == 'string' && typeof window[fn] == 'function') {
					window[fn](link);
				}
				hide_modal();
				return false;
			});
		});

		return false;
	});
	
	$('#modal-content form').live('submit', function () {
		$(this).append('<input type="hidden" name="phpcan_ajax" value="true" />');

		$(this).ajaxSubmit({
			'success': function (data) {
				$('#modal-content').html(data);

				if (scroll) {
					window.scrollTo(0, scroll);
				}

				message_effect('#modal-content');
			}
		});

		return false;
	});
	
	$('#modal-close').live('click', function () {
		hide_modal();
		return false;
	});
});

//Modal functions
var scroll = 0;

function hide_modal() {
	$('#modal-content').slideUp('normal', function() {
		$('#modal').slideUp('fast');
	});
}
function show_modal() {
	var height = $(document).height();

	$('#modal-content').hide();
	$('#modal-background').css('height', height + 'px');

	move_modal();

	$('#modal').show();
	$('#modal-content').slideDown('normal', function () {
		height = $(document).height();
		$('#modal-background').css('height', height + 'px');
	});
}
function move_modal() {
	scroll = $(window).attr('pageYOffset');
	$('#modal div.page').css('top', scroll + 'px');
}

//Message effect
function message_effect (place) {
	if (place) {
		place = $(place + ' .message');
	} else {
		place = $('.message');
	}
	var p = $('p', place);

	$(p).hide();
	$(p).fadeIn('slow');

	$('.message-close', p).click(function () {
		$(place).fadeOut('slow');
		return false;
	});
}

//submitConfirm function
function submitConfirm (text, url) {
	if (confirm(text) && action) {
		if (typeof url != 'undefined') {
			$('form#edit').attr('action', url);
		}
		return true;
	}

	return false;
}

//linkConfirm function
function linkConfirm (text, object, fn) {
	if (confirm(text)) {
		var href = $(object).attr('href');

		$.get(href, function (text) {
			if (fn && typeof fn == 'string' && typeof window[fn] == 'function') {
				window[fn](object, text);
			}
		});
	}

	return false;
}

//print_r function (like print_r in php)
function print_r (arr, level) {
	var dumped_text = "";
	if (!level) {
		level = 0;
	}

	var level_padding = "";
	for (var j=0; j<level+1; j++) {
		level_padding += "    ";
	}

	if (typeof(arr) == 'object') {
		for (var item in arr) {
			var value = arr[item];
			
			if(typeof(value) == 'object') {
				dumped_text += level_padding + "'" + item + "' ...\n";
				dumped_text += dump(value,level+1);
			} else {
				dumped_text += level_padding + "'" + item + "' => \"" + value + "\"\n";
			}
		}
	} else {
		dumped_text = "===>"+arr+"<===("+typeof(arr)+")";
	}

	return dumped_text;
}
