<?php
/**
* phpCan v.1
*
* $Id: index.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

$sceneCustom = $config->paths['scene-config'].getenv('SERVER_NAME').'/';

//Common includes
require_once ($config->paths['scene-config'].'base.php');
require_once ($config->paths['scene-config'].'db.php');
require_once ($config->paths['scene-config'].'tables.php');

if (is_dir($sceneCustom)) {
	if (is_file($sceneCustom.'base.php'))       include_once ($sceneCustom.'base.php');
	if (is_file($sceneCustom.'db.php'))         include_once ($sceneCustom.'db.php');
	if (is_file($sceneCustom.'tables.php'))     include_once ($sceneCustom.'tables.php');
}

//Templates path
$config->paths['www-scene-templates'] .= $config->base['template'].'/';
$config->paths['www-admin-templates'] .= $config->base['admin_template'].'/';
$config->paths['scene-templates'] .= $config->base['template'].'/';
$config->paths['admin-templates'] .= $config->base['admin_template'].'/';

//Debug init
$debug->start();

//Set language
$config->setLanguage();

//Admin mode
if ($vars->isAdmin()) {
	include_once ($config->paths['admin-config'].'actions.php');
	include_once ($config->paths['admin-config'].'events.php');
	include_once ($config->paths['admin-config'].'data.php');
	include_once ($config->paths['admin-config'].'templates.php');
	include_once ($config->paths['scene-config'].'admin_tables.php');

	$adminCustom = $config->paths['admin-config'].getenv('SERVER_NAME').'/';

	if (is_dir($adminCustom)) {
		if (is_file($adminCustom.'actions.php'))    include_once ($adminCustom.'actions.php');
		if (is_file($adminCustom.'events.php'))    include_once ($adminCustom.'events.php');
		if (is_file($adminCustom.'data.php'))       include_once ($adminCustom.'data.php');
		if (is_file($adminCustom.'templates.php'))  include_once ($adminCustom.'templates.php');
	}

	if (is_dir($sceneCustom)) {
		if (is_file($sceneCustom.'admin_tables.php'))  include_once ($sceneCustom.'admin_tables.php');
	}

//Public mode
} else {
	include_once ($config->paths['scene-config'].'actions.php');
	include_once ($config->paths['scene-config'].'events.php');
	include_once ($config->paths['scene-config'].'data.php');
	include_once ($config->paths['scene-config'].'templates.php');

	if (is_dir($sceneCustom)) {
		if (is_file($sceneCustom.'actions.php'))    include_once ($sceneCustom.'actions.php');
		if (is_file($sceneCustom.'events.php'))    include_once ($sceneCustom.'events.php');
		if (is_file($sceneCustom.'data.php'))       include_once ($sceneCustom.'data.php');
		if (is_file($sceneCustom.'templates.php'))  include_once ($sceneCustom.'templates.php');
	}
}

unset($sceneCustom, $adminCustom);
?>
