<?php
/**
* phpCan v.1
*
* $Id: email.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatEmail extends Formats {
	var $format = 'email';

	public function check ($value) {
		$this->error = array();

		if (is_array($value)) {
			$value = $value[$this->name];
		}

		$settings = $this->settings[$this->name];

		if ($settings['required'] && empty($value)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
  		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s characters', $settings['length_max']);

			return false;
		}

		if (!preg_match('/^[a-z0-9][a-z0-9_\.-]*@[a-z0-9\.-]+\.[a-z]{2,4}$/i', $value)) {
			$this->error[$this->name] = __('This field should has a valid format');

			return false;
		}

		return true;
	}

	public function settings ($settings) {
		$settings['length_max'] = $settings['length_max'] ? intval($settings['length_max']) : 100;

		$this->settings = array(
			$this->name => array(
				'db_type' => 'varchar',
				'db_length_max' => $settings['length_max'],

				'length_max' => $settings['length_max'],
				'required' => $settings['required'] ? true : false
			)
		);

		return $this->settings;
	}
}
?>
