<?php
/**
* phpCan v.1
*
* $Id: enum.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatEnum extends Formats {
	var $format = 'enum';

	public function check ($value) {
		$this->error = array();

		if (is_array($value)) {
			$value = $value[$this->name];
		}

		$settings = $this->settings[$this->name];

		if (!empty($value) && !in_array($value, explode(',', $settings['values']))) {
			$this->error[$this->name] = __('This field should has a valid value');

			return false;
		}

		return true;
	}

	public function settings ($settings) {
		$values = explode(',', $settings['values']);
		$default = !in_array($settings['default'], $values)?$values[0]:$settings['default'];

		$this->settings = array(
			$this->name => array(
				'db_type' => 'enum',
				'db_values' => $values,
				'db_default' => $default,
				
				'default' => $default,
				'values' => $settings['values'],
			)
		);

		return $this->settings;
	}
}
?>
