<?php
/**
* phpCan v.1
*
* $Id: file.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatFile extends Formats {
	var $format = 'file';

	public function check ($value) {
		global $debug;

		$this->error = array();

		$settings = $this->settings[$this->name];

		if ($settings['required'] && ($value['size'] == 0)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
		} else if ($value['size'] > $settings['max_size']) {
			$this->error[$this->name] = __('This file exceds the file size limit');

			return false;
		} else if (!recursiveFolder($settings['folder_root'])) {
			$this->error[$this->name] = __('The folder to store the file don\'t exists');

			return false;
		} else if (!is_writable($settings['folder_root'])) {
			$this->error[$this->name] = __('The folder to store the file haven\'t writing permissions');

			return false;
		}

		return true;
	}

	public function valueDB ($value) {
		global $debug;

		$value = $value[$this->name];

		if (($value['size'] == 0) || !is_file($value['tmp_name'])) {
			$this->newValue = $this->oldValue;

			return array($this->name => $this->newValue);
		}

		$value['name'] = filename($value['name']);

		while (is_file($this->settings[$this->name]['folder_root'].$value['name'])) {
			$value['name'] = rand(0, 9999).'-'.$value['name'];
		}

		if (move_uploaded_file($value['tmp_name'], $this->settings[$this->name]['folder_root'].$value['name'])) {
			$this->newValue = $this->settings[$this->name]['folder_www'].$value['name'];
		} else {
			$this->newValue = $this->oldValue;
		}

		return array($this->name => $this->newValue);
	}

	public function afterSave ($id) {
		if ($this->newValue == $this->oldValue) {
			return true;
		}

		if ($id == 0) {
			$file = end(explode('/', $this->newValue));
		} else {
			$file = end(explode('/', $this->oldValue));
		}

		if (is_file($this->settings[$this->name]['folder_root'].$file)) {
			unlink($this->settings[$this->name]['folder_root'].$file);
		}

		return true;
	}

	public function settings ($settings) {
		if (!$settings['folder_root']) {
			global $config;

			$settings['folder_root'] = $config->paths['scene-uploads'];
			$settings['folder_www'] = $config->paths['www-scene-uploads'];
		}

		$this->settings = array(
			$this->name => array(
				'db_type' => 'varchar',
				'db_length_max' => 225,

				'max_size' => $settings['max_size'] ? toBytes($settings['max_size']) : toBytes(ini_get('upload_max_filesize')),
				'valid_extensions' => is_array($settings['valid_extensions']) ? $settings['valid_extensions'] : array('doc','docx','pdf','txt'),
				'folder_root' => $settings['folder_root'],
				'folder_www' => $settings['folder_www'],
				'dir' => $settings['dir'] ? $settings['dir'].'/' : $this->name.'/',
				'required' => $settings['required'] ? true : false
			)
		);

		return $this->settings;
	}
}
?>
