<?php
/**
* phpCan v.1
*
* $Id: float.php 340 2009-07-17 17:15:49Z lito $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatFloat extends Formats {
	var $format = 'float';

	public function check ($value, $field_name) {
		$this->error = array();

		if (is_array($value)) {
			$value = $value[$this->name];
		}

		$settings = $this->settings[$this->name];

		if ($settings['required'] && (empty($value) || $value == '0,0')) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
  		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s numbers', $settings['length_max']);

			return false;
		}

		if (preg_match('/^-?[0-9,\.]*$/', $vars->var[$this->name])) {
			return true;
		} else {
			$this->error[$this->name] = __('The value is not a valid number.');

			return false;
		}
	}

	public function settings ($settings) {
		list($int, $dec) = explode(',', $settings['length_max']);

		$int = (intval($int) == 0)?8:intval($int);
		$dec = (intval($dec) == 0)?2:intval($dec);

		$settings['length_max'] = $int.', '.$dec;

		$this->settings = array(
			$this->name => array(
				'db_type' => 'float',
				'db_length_max' => $settings['length_max'],
				'db_unsigned' => isset($settings['unsigned'])?$settings['unsigned']:true,
				'db_default' => '0.0',

				'default' => '0,0',
				'required' => $settings['required'] ? true : false
			)
		);

		return $this->settings;
	}
}
?>
