<?php
/**
* phpCan v.1
*
* $Id: floatinterval.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatFloatinterval extends Formats {
	var $format = 'floatinterval';

	public function check ($value) {
		$this->error = array();

		$setStart = $this->settings[$this->name.'_start'];
		$setEnd = $this->settings[$this->name.'_end'];
		$valStart = $value[$this->name.'_start'];
		$valEnd = $value[$this->name.'_end'];
		
		if ($setStart['required'] && empty($valStart)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
	  	}

	  	if ($setEnd['required'] && empty($valEnd)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
	  	}
	  	
	  	if ($valStart > $valEnd) {
	  		$this->error[$this->name] = __('The start value can not be bigger that end value');

	  		return false;
	  	}

		if (preg_match('/^-?[0-9]*\.?[0-9]*$/', $valStart) && preg_match('/^-?[0-9]*\.?[0-9]*$/', $valEnd)) {
			return true;
		} else {
			$this->error[$this->name] = __('The value is not a valid number.');

			return false;
		}
	}

	public function valueDB ($value) {
		return array(
			$this->name.'_start' => round(floatval($value[$this->name.'_start']), 1),
			$this->name.'_end' => round(floatval($value[$this->name.'_end']), 1)
		);
	}

	public function settings ($settings) {
		$this->settings = array(
			$this->name.'_start' => array(
				'db_type' => 'float',
				'db_length_max' => '6,1',
				'db_default' => '0.0',
				'db_unsigned' => true
				
				'subformat' => 'start',
				'required' => $settings['required'] ? true : false
			),
			$this->name.'_end' => array(
				'db_type' => 'float',
				'db_length_max' => '6,1',
				'db_default' => '0.0',
				'db_unsigned' => true
				
				'subformat' => 'end',
				'required' => $settings['required'] ? true : false
			)
		);

		return $this->settings;
	}
}
?>
