<?php
/**
* phpCan v.1
*
* $Id: integer.php 340 2009-07-17 17:15:49Z lito $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatInteger extends Formats {
	var $format = 'integer';

	public function check ($value) {
		$this->error = array();

		if (is_array($value)) {
			$value = $value[$this->name];
		}

		$settings = $this->settings[$this->name];

		if ($settings['required'] && !intval($value)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
  		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s numbers', $settings['length_max']);

			return false;
		}

		if (preg_match('/^-?[0-9]*$/', $value)) {
			return true;
		} else {
			$this->error[$this->name] = __('The value is not a valid number.');

			return false;
		}
	}

	public function settings ($settings) {
		$settings['db_type'] = 'integer';

		if ($settings['val_max']) {
			$settings['db_length_max'] = strlen($settings['val_max']);
			
			if ($settings['val_max'] <= 255) {
				$settings['db_type'] = 'tinyint';
			}
		} else if ($settings['length_max']) {
			$settings['db_length_max'] = $settings['length_max'];
		} else {
			$settings['db_length_max'] = 8;
		}

		$this->settings = array(
			$this->name => array(
				'db_type' => $settings['db_type'],
				'db_length_max' => $settings['db_length_max'],
				'db_unsigned' => isset($settings['db_unsigned'])?$settings['db_unsigned']:true,
				'db_index' => $settings['index'],
				'db_key' => $settings['key'],
				'db_unique' => $settings['unique'],
				'db_default' => intval($settings['default']),

				'default' => intval($settings['default']),
				'required' => $settings['required'] ? true : false,
				'length_max' => $settings['db_length_max'],
				'val_max' => $settings['val_max'],
			)
		);

		return $this->settings;
	}
}
?>
