<?php
/**
* phpCan v.1
*
* $Id: password.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatPassword extends Formats {
	var $format = 'password';

	public function check ($value) {
		global $vars;

		$this->error = array();

		if (is_array($value)) {
			$value = $value[$this->name];
		}

		$value_repeat = $vars->var[$this->name.'_repeat'];
		$settings = $this->settings[$this->name];

		if (($vars->var['id'] > 0) && empty($value)) {
			return true;
		}

		if ($settings['length_min'] && (strlen($value) < $settings['length_min'])) {
			$this->error[$this->name] = __('This field should has more than %s characters', $settings['length_min']);

			return false;
		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s characters', $settings['length_max']);

			return false;
		}

		if ($value != $value_repeat) {
			$this->error[$this->name] = __('This field and repeat field must have the same value');

			return false;
		}

		return true;
	}

	public function valueDB ($value) {
		return array($this->name => md5($value[$this->name]));
	}

	public function valueForm ($value) {
		return array($this->name => '');
	}

	public function settings ($settings) {
		$this->settings = array(
			$this->name => array(
				'db_type' => 'varchar',
				'db_length_max' => 32,
			)
		);

		return $this->settings;
	}
}
?>
