<?php
/**
* phpCan v.1
*
* $Id: positionxy.php 351 2009-07-23 20:17:53Z oscar $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatPositionxy extends Formats {
	var $format = 'positionxy';

	public function check ($value) {
		$this->error = array();

		$setx = $this->settings[$this->name.'_x'];
		$sety = $this->settings[$this->name.'_y'];
		$valx = $value[$this->name.'_x'];
		$valy = $value[$this->name.'_y'];
		
		if ($setx['required'] && empty($valx) && $valx != '0') {
			$this->error[$this->name]['x'] = __('This field can not be empty');
			return false;
	  	} else if ($setx['val_max'] && $valx > $setx['val_max']) {
			$this->error[$this->name]['x'] = __('The max value of this field is %s', $setx['val_max']);
			return false;
	  	} else if ($setx['val_min'] && $valx < $setx['val_min']) {
	  		$this->error[$this->name]['x'] = __('The min value of this field is %s', $setx['val_min']);
			return false;
	  	} else if (!preg_match('/^[0-9]*$/', $valx)) {
			$this->error[$this->name]['x'] = __('The value is not a valid number.');
			return false;
		}


	  	if ($sety['required'] && empty($valy) && $valy != '0') {
			$this->error[$this->name]['y'] = __('This field can not be empty');
			return false;
	  	} else if ($sety['val_max'] && $valy > $sety['val_max']) {
			$this->error[$this->name]['y'] = __('The max value of this field is %s', $sety['val_max']);
			return false;
	  	} else if ($sety['val_min'] && $valy < $sety['val_min']) {
	  		$this->error[$this->name]['y'] = __('The min value of this field is %s', $sety['val_min']);
			return false;
	  	} else if (!preg_match('/^[0-9]*$/', $valy)) {
			$this->error[$this->name]['y'] = __('The value is not a valid number.');
			return false;
	  	}

		return true;
	}

	public function valueDB ($value) {
		return array(
			$this->name.'_x' => round(intval($value[$this->name.'_x'])),
			$this->name.'_y' => round(intval($value[$this->name.'_y']))
		);
	}

	public function settings ($settings) {
		if (!$settings['val_max']) {
			$settings['val_max'] = 9999;
		}
		if (!$settings['val_min']) {
			$settings['val_min'] = 0;
		}
		$settings['db_unsigned'] = $settings['val_min'] < 0 ? false : true;
		$settings['db_length_max'] = strlen($settings['val_max']);
		$settings['db_type'] = $settings['val_max'] > 255 ? 'integer' : 'tinyint';

		$this->settings = array(
			$this->name.'_x' => array(
				'db_type' => $settings['db_type'],
				'db_unsigned' => $settings['db_unsigned'],
				'db_default' => 0,
				'db_length_max' => $settings['db_length_max'],

				'subformat' => 'x',
				'val_max' => $settings['val_max'],
				'val_min' => $settings['val_min'],
				'required' => $settings['required'] ? true : false,
			),
			$this->name.'_y' => array(
				'db_type' => $settings['db_type'],
				'db_unsigned' => $settings['db_unsigned'],
				'db_default' => 0,
				'db_length_max' => $settings['db_length_max'],
				
				'subformat' => 'y',
				'val_max' => $settings['val_max'],
				'val_min' => $settings['val_min'],
				'required' => $settings['required'] ? true : false,
			)
		);

		return $this->settings;
	}
}
?>
