<?php
/**
* phpCan v.1
*
* $Id: secondinterval.php 351 2009-07-23 20:17:53Z oscar $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatSecondinterval extends Formats {
	var $format = 'secondinterval';

	public function check ($value) {
		$this->error = array();

		$setStart = $this->settings[$this->name.'_start'];
		$setEnd = $this->settings[$this->name.'_end'];
		$valStart = $value[$this->name.'_start'];
		$valEnd = $value[$this->name.'_end'];
		
		if ($setStart['required'] && empty($valStart) && $valStart != '0') {
			$this->error[$this->name]['start'] = __('This field can not be empty');

			return false;
	  	}

	  	if ($setEnd['required'] && empty($valEnd) && $valStart != '0') {
			$this->error[$this->name]['end'] = __('This field can not be empty');

			return false;
	  	}
	  	
	  	if ($valStart > $valEnd) {
	  		$this->error[$this->name]['end'] = __('The start value can not be bigger that end value');

	  		return false;
	  	}

		if (!preg_match('/^-?[0-9]*\.?[0-9]*$/', $valStart)) {
			$this->error[$this->name]['start'] = __('The value is not a valid number.');

			return false;
		}

		if (!preg_match('/^-?[0-9]*\.?[0-9]*$/', $valEnd)) {
			$this->error[$this->name]['end'] = __('The value is not a valid number.');

			return false;
		}

		return true;
	}

	public function valueDB ($value) {
		return array(
			$this->name.'_start' => round(floatval($value[$this->name.'_start']), 1),
			$this->name.'_end' => round(floatval($value[$this->name.'_end']), 1)
		);
	}

	public function valueForm ($value) {
		return array(
			$this->name.'_start' => $value[$this->name.'_start'],
			$this->name.'_end' => $value[$this->name.'_end']
		);
	}

	public function settings ($settings) {
		$this->settings = array(
			$this->name.'_start' => array(
				'db_type' => 'float',
				'db_length_max' => '6,1',
				'db_default' => '0.0',
				'db_unsigned' => true,
				
				'subformat' => 'start',
				'required' => $settings['required'] ? true : false
			),
			$this->name.'_end' => array(
				'db_type' => 'float',
				'db_length_max' => '6,1',
				'db_default' => '0.0',
				'db_unsigned' => true,
				
				'subformat' => 'end',
				'required' => $settings['required'] ? true : false
			),
		);

		return $this->settings;
	}
}
?>
