<?php
/**
* phpCan v.1
*
* $Id: text.php 311 2009-07-15 15:59:28Z oscar $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatText extends Formats {
	var $format = 'text';

	public function check ($value) {
		$this->error = array();

		if (is_array($value)) {
			$value = $value[$this->name];
		}

		$settings = $this->settings[$this->name];

		if ($settings['required'] && empty($value)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
  	}

		if ($settings['length_min'] && (strlen($value) < $settings['length_min'])) {
			$this->error[$this->name] = __('This field should has more than %s characters', $settings['length_min']);

			return false;
		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s characters', $settings['length_max']);

			return false;
		}

		return true;
	}

	public function valueForm ($value) {
		return array($this->name => escapeForm($value[$this->name]));
	}

	public function settings ($settings) {
		$settings['length_max'] = intval($settings['length_max']);

		$this->settings = array(
			$this->name => array(
				'db_type' => 'text',
				'db_length_max' => $settings['length_max'],

				'length_min' => intval($settings['length_min']),
				'required' => $settings['required'] ? true : false
			)
		);

		return $this->settings;
	}
}
?>
