<?php
/**
* phpCan v.1
*
* $Id: title.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatTitle extends Formats {
	var $format = 'title';

	public function check ($value) {
		$this->error = array();

		$settings = $this->settings[$this->name];
		$value = $value[$this->name.'_title'];

		if ($settings['required'] && empty($value)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
	  }

		if ($settings['length_min'] && (strlen($value) < $settings['length_min'])) {
			$this->error[$this->name] = __('This field should has more than %s characters', $settings['length_min']);

			return false;
		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s characters', $settings['length_max']);

			return false;
		}

		return true;
	}

	public function valueDB ($value) {
		global $data;

		$url_text = $value[$this->name.'_title'];

		$search = array  ('á','é','í','ó','ú','à','è','ì','ò','ù','â','ê','î','ô','û','ä','ë','ï','ö','ü','Á','É','Í','Ó','Ú','À','È','Ì','Ò','Ù','Â','Ê','Î','Ô','Û','Ä','Ë','Ï','Ö','Ü','ñ','Ñ','ç','Ç',' ','--');
		$replace = array ('a','e','i','o','u','a','e','i','o','u','a','e','i','o','u','a','e','i','o','u','A','E','I','O','U','A','E','I','O','U','A','E','I','O','U','A','E','I','O','U','n','N','c','C','-','-');

		$url_text = str_replace($search, $replace, trim($url_text));
		$url_text = strtolower($url_text);
		$url_text = preg_replace('/[^a-z0-9_-]/', '', $url_text);

		return array(
			$this->name.'_title' => $data->escapeString($value[$this->name.'_title']),
			$this->name.'_url' => $url_text
		);
	}

	public function settings ($settings) {
		if (($settings['length_max'] > 255) || ($settings['length_max'] < 1)) {
			$settings['length_max'] = 255;
		}
		$settings['length_max'] = intval($settings['length_max']);

		if ($settings['length_min'] > 254) {
			$settings['length_min'] = 254;
		} else if ($settings['length_min'] < 0) {
			$settings['length_min'] = 0;
		}
		$settings['length_min'] = intval($settings['length_min']);

		$this->settings = array(
			$this->name.'_title' => array(
				'db_type' => 'varchar',
				'db_length_max' => $settings['length_max'],

				'subformat' => 'title',
				'required' => $settings['required'] ? true : false,
				'length_max' => $settings['length_max'],
				'length_min' => $settings['length_min'],
			),
			$this->name.'_url' => array(
				'db_type' => 'varchar',
				'db_length_max' => $settings['length_max'],
				'db_unique' => $this->name,

				'subformat' => 'url',
				'length_max' => $settings['length_max'],
				'length_min' => $settings['length_min'],
			)
		);

		return $this->settings;
	}
}
?>
