<?php
/**
* phpCan v.1
*
* $Id: varchar.php 340 2009-07-17 17:15:49Z lito $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatVarchar extends Formats {
	var $format = 'varchar';

	public function check ($value) {
		$this->error = array();

		$settings = $this->settings[$this->name];
		$value = $value[$this->name];

		if ($settings['required'] && empty($value)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
	  	}

		if ($settings['length_min'] && (strlen($value) < $settings['length_min'])) {
			$this->error[$this->name] = __('This field should has more than %s characters', $settings['length_min']);

			return false;
		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s characters', $settings['length_max']);

			return false;
		}

		return true;
	}

	public function valueForm ($value) {
		return array($this->name => escapeForm($value[$this->name]));
	}

	public function settings ($settings) {
		if (($settings['length_max'] > 255) || ($settings['length_max'] < 1)) {
			$settings['length_max'] = 255;
		}

		$settings['length_max'] = intval($settings['length_max']);

		if ($settings['length_min'] > 254) {
			$settings['length_min'] = 254;
		} else if ($settings['length_min'] < 0) {
			$settings['length_min'] = 0;
		}

		$settings['length_min'] = intval($settings['length_min']);

		$this->settings = array(
			$this->name => array(
				'db_type' => 'varchar',
				'db_length_max' => $settings['length_max'],
				'db_index' => $settings['index'],
				'db_key' => $settings['key'],
				'db_unique' => $settings['unique'],

				'required' => $settings['required'] ? true : false,
				'length_max' => $settings['length_max'],
				'length_min' => $settings['length_min'],
			)
		);

		return $this->settings;
	}
}
?>
