<?php
/**
* phpCan v.1
*
* $Id: video_file_name.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

include_once ($config->paths['includes'].'class_formats.php');

class FormatVideo_file_name extends Formats {
	var $format = 'video_file_name';

	public function check ($value) {
		$this->error = array();

		$settings = $this->settings[$this->name];
		$value = $value[$this->name];

		if ($settings['required'] && empty($value)) {
			$this->error[$this->name] = __('This field can not be empty');

			return false;
	  	}

	  	if (empty($value)) {
	  		return true;
	  	}

		if ($settings['length_min'] && (strlen($value) < $settings['length_min'])) {
			$this->error[$this->name] = __('This field should has more than %s characters', $settings['length_min']);

			return false;
		}

		if ($settings['length_max'] && (strlen($value) > $settings['length_max'])) {
			$this->error[$this->name] = __('This field should has less than %s characters', $settings['length_max']);

			return false;
		}

		if (!is_file($settings['media_dir'].$settings['dir'].$value)) {
			$this->error[$this->name] = __('The file "%s" doesn\'t exists', $settings['media_dir'].$settings['dir'].$value);

			return false;
		}
		
		if (!in_array(pathinfo($value, PATHINFO_EXTENSION), $settings['valid_extensions'])) {
			$this->error[$this->name] = __('The file extension of "%s" is not valid', $value);

			return false;
		}

		return true;
	}

	public function settings ($settings) {
		if (($settings['length_max'] > 255) || ($settings['length_max'] < 1)) {
			$settings['length_max'] = 50;
		}
		$settings['length_max'] = intval($settings['length_max']);

		if ($settings['length_min'] > 254) {
			$settings['length_min'] = 254;
		} else if ($settings['length_min'] < 0) {
			$settings['length_min'] = 0;
		}
		$settings['length_min'] = intval($settings['length_min']);

		if (!$settings['media_dir']) {
			global $config;

			$settings['media_dir'] = $config->paths['scene-uploads'];
			$settings['www-media_dir'] = $config->paths['www-scene-uploads'];
		}

		$this->settings = array(
			$this->name => array(
				'db_type' => 'varchar',
				'db_length_max' => $settings['length_max'],

				'required' => $settings['required'] ? true : false,
				'length_max' => $settings['length_max'],
				'length_min' => $settings['length_min'],
				'dir' => $settings['dir'] ? $settings['dir'].'/' : $this->name.'/',
				'media_dir' => $settings['media_dir'],
				'www-media_dir' => $settings['www-media_dir'],
				'valid_extensions' => is_array($settings['valid_extensions']) ? $settings['valid_extensions'] : array('flv', 'mp4')
			)
		);

		return $this->settings;
	}
}
?>
