<?php
/**
* phpCan v.1
*
* $Id: actions.php 339 2009-07-17 16:12:33Z lito $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

$actions = $vars->arr('phpcan_action');

//Delete actions (for future redirects)
$vars->delete('phpcan_action');

if (!$actions) {
	return false;
}

$isAdmin = $vars->isAdmin();

foreach ($actions as $action => $value) {
	//Exists the action?
	if (!isset($config->actions[$action])) {
		$debug->action(__('This action doesn\'t exists'));

		continue;
	}

	//Action must be an array
	if (!is_array($config->actions[$action])) {
		$config->actions[$action] = array('file' => $config->actions[$action]);
	}

	//Is disabled?
	$disabled = isset($config->actions[$action]['disabled']) ? $config->actions[$action]['disabled'] : $config->actions['default']['disabled'];
	if ($disabled) {
		continue;
	}

	//Are controllers defined?
	$controllers = isset($config->actions[$action]['controllers']) ? $config->actions[$action]['controllers'] : $config->actions['default']['controllers'];

	if (is_array($controllers) && $controllers && !in_array($vars->getController(), $controllers)) {
		$debug->action($config->actions[$action]);
		continue;
	}

	//Exists the action file?
	$file = filename($config->actions[$action]['file'] ? $config->actions[$action]['file'] : $action);
	$dir = $isAdmin ? 'admin-actions' : 'scene-actions';

	if (!is_file($config->paths[$dir].$file.'.php')) {
		$debug->action($config->actions[$action]);
		continue;
	}

	//Exists a check file?
	$checkfile = isset($config->actions[$action]['check_file']) ? $config->actions[$action]['check_file'] : $config->actions['default']['check_file'];
	$checkfile = filename($checkfile);

	if ($checkfile) {
		if (!is_file($config->paths[$dir].$checkfile.'.php')) {
			$debug->action($config->actions[$action]);
			continue;
		}

		$val = include($config->paths[$dir].$checkfile.'.php');
	} else {
		$val = true;
	}

	if ($val === true) {
		include_once ($config->paths[$dir].$file.'.php');
	}

	//Redirect to another page
	if ($config->actions[$action]['load'] && !$data->error) {
		redirect($config->actions[$action]['load']);
	}

	//Change the ajax_template & ajax_data

	if (isAjax()) {
		if ($config->actions[$action]['ajax_template']) {
			$config->templates[$vars->getController()]['ajax'] = $config->actions[$action]['ajax_template'];
		}
		if ($config->actions[$action]['ajax_data']) {
			$config->data[$vars->getController()] = $config->actions[$action]['ajax_data'];
			$config->data['default'] = array();
		}
	
	//Reload
	} else {
		$reload = isset($config->actions[$action]['reload']) ? $config->actions[$action]['reload'] : $config->actions['default']['reload'];

		if ($reload && !$data->error) {

			redirect(path().get());
		}
	}
}

unset($actions, $action, $value, $reload, $controllers, $file, $dir, $disabled);
?>
