<?php
/**
* phpCan v.1
*
* $Id: class_data.php 339 2009-07-17 16:12:33Z lito $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

global $config;

require_once ($config->paths['includes'].'class_db.php');

class Data extends DB {
	public $data = array();

	public function __construct () {
		global $config;

		$this->setTables();
		$this->setRelations();

		foreach ($config->data as $controller => $contents) {
			if (strstr($controller, ',')) {
				$controllers = explode(',', $controller);

				foreach ($controllers as $val) {
					$config->data[trim($val)] = array_merge((array)$config->data[$val], (array)$contents);
				}

				unset($config->data[$controller]);
			}
		}
	}

	public function register ($store, $value = array()) {
		if (empty($store)) {
			return false;
		}

		$store = preg_replace('/\W/', '_', strtolower($store));

		if (!in_array($store, $this->data)) {
			global $$store;

			$$store = $value;

			$this->data[] = $store;
		} else {
			global $debug;

			$debug->db(__('The variable %s has been previously registered'));
		}

		return true;
	}

	public function load ($file) {
		global $config, $vars;

		$dir = $vars->isAdmin() ? 'admin-data' : 'scene-data';
		$file = $config->paths[$dir].$file.'.php';

		if (is_file($file)) {
			return $file;
		} else {
			global $debug;

			$debug->data('The data file "'.$file.'" doesn\'t exists');

			return $config->paths['includes'].'utils/empty_template.php';
		}
	}
}
?>
