<?php
/**
* phpCan v.1
*
* $Id$
*
* 2009 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();


class File {

	/**
	* public function filename (string $file)
	*
	* return string
	*/
	public function filename ($file) {
		return preg_replace(array('/\.+/', '/[^\w\.-]/'), array('.', '_'), $file);
	}


	/**
	* public function makeFolder (string $folder)
	*
	* return boolean
	*/
	public function makeFolder ($folder) {
		if (is_dir($folder)) {
			return true;
		}

		$dirs = explode('/', $folder);
		$dir = array_shift($dirs);

		if (!strpos($dir, ':')) {
			$dir = '/'.$dir;
		}

		foreach ($dirs as $part) {
			if (empty($part) || ($part == '.')) {
				continue;
			}

			$dir .= '/'.$part;

			if ($part == '..') {
				continue;
			}

			if (!is_dir($dir)) {
				$ok = @mkdir($dir, 0755);

				if (!$ok) {
					return false;
				}
			}
		}

		clearstatcache();

		return is_dir($folder);
	}
	
	
	/**
	* public saveUploadedFile (string/array $file, string $dir, [bool $replace])
	*
	* return boolean/string
	*/
	public saveUploadedFile ($file, $dir, $replace = false) {
		if (is_string($file)) {
			$file = $_FILES[$file];
		}

		if ($file['size'] == 0 || !is_file($file['tmp_name'])) {
			return false;
		}

		$new_file = pathinfo($file['name']);

		$new_file['filename'] = $this->filename($new_file['filename']);

		if (!$replace && is_file($dir.$new_file['filename'].'.'.$new_file['extension'])) {
			$new_name = $new_file['filename'].'-';

			while (is_file($dir.$new_file['filename'].'.'.$new_file['extension'])) {
				$new_file['filename'] = $new_name.rand(0, 9999);
			}
		}

		if (move_uploaded_file($file['tmp_name'], $dir.$new_file['filename'].'.'.$new_file['extension'])) {
			return $new_file['filename'].'.'.$new_file['extension'];
		} else {
			return false;
		}
	}
}
?>