<?php
/**
* phpCan v.1
*
* $Id: class_formats.php 194 2009-06-25 16:19:56Z eordes $
*
* 2008 Copyright - phpCan is released under the GNU Affero GPL version 3
*
* More information at license.txt
*/

defined('ANS') or die();

abstract class Formats {
	var $name;
	var $table;
	var $format;
	var $settings;
	var $error;
	var $oldValue;
	var $newValue;

	public function __construct ($table, $field, $settings = array()) {
		$this->table = $table;
		$this->name = $field;

		return $this->settings($settings);
	}

	abstract protected function check ($value);
	abstract protected function settings ($settings);

	public function valueDB ($value) {
		global $data;

		$array = array();

		foreach ($this->settings as $name => $setting) {
			switch ($setting['db_type']) {
				case 'tinyint':
				case 'smallint':
				case 'mediumint':
				case 'integer':
				case 'bigint':
				case 'bool':
					$array[$name] = intval($value[$name]);
					break;

				case 'float':
				case 'double':
					$array[$name] = floatval($value[$name]);
					break;

				default:
					$array[$name] = $data->escapeString($value[$name]);
					break;
			}
		}

		return $array;
	}

	public function valueForm ($value) {
		$array = array();

		foreach ($this->settings as $name => $v) {
			$array[$name] = $value[$name];
		}

		return $array;
	}

	public function afterSave ($id) {
		return true;
	}
}
?>